#
# Mooshak: managing programming contests on the web		April 2001
# 
#			Zé Paulo Leal 		
#			zp@ncc.up.pt
#
#-----------------------------------------------------------------------------
# file: Groups.tcl
# 
## LDAP data
##

package provide LDAP 1.0

package require data

namespace eval LDAP {

}


Attributes LDAP {
    Command	text	{}
    Host	text	{}
    Bind_DN	text	{}
    Base_DN	text	{}
}

## Authenticate user in this LDAP server
## Returns hash if user is authenticated and {} otherwise
Operation LDAP::authenticate {user password} {
    
    set command_line 						\
	[ format 						\
	      {%s -LLL -x -D%s -b%s -h %s -w "%s" uid=%s userPassword} 	\
	      $Command						\
	      "uid=$user,$Bind_DN"				\
	      $Base_DN  					\
	      $Host						\
	      $password	 $user ]

    set fd [ ::open "| $command_line " r ]    

    if { [ catch { 
	gets $fd dn
	gets $fd hash
	::close $fd 
    }  ] } {
	set hash "" ;# not authenticated
    }
    return $hash
}


Operation LDAP::ldap:test ! {
    
    set user 	 nobody
    set password ?
    set command_line 						\
	[ format 						\
	      {%s -LLL -x -D%s -b%s -h %s -w "%s" uid=%s userPassword} 	\
	      $Command						\
	      "uid=$user,$Bind_DN"				\
	      $Base_DN  					\
	      $Host						\
	      $password	 $user ]

    set output ""
    if { [ catch { 
	set fd [ ::open "| $command_line " r ]    
	while { [ gets $fd line ] > -1 } {
	    append output $line\n
	}
	::close $fd 
    } msg ] } {
	append output $msg
    }

    if [ regexp "ldap_bind:" $output ] {
	set message  [ translate::sentence "LDAP server is reachable" ]
    } else {

	set message [ format "%s: %s" 					\
			  [ translate::sentence 			\
				"Unexpected output from LDAP server" ] 	\
			  $output ]
    }
    layout::alert $message

    content::show ${_Self_}

}
